#include<stdio.h>
#include<sys/types.h>
#include<sys/socket.h>
#include<string.h>
#include<netinet/in.h>
#include<pthread.h>

#include"ytsSocket.h"

#define SERV_IP "127.0.0.1"
#define CLIENT_PORT 6666
#define MONITOR_PORT 5555

int Bind_socket();
void *Client_Service(void*);
void *Output_Service(void*);

struct prodcons buffer;         /* 全局的环形缓冲区 */

int main(int argc, char *argv[])
{
    
    int clifd,clientfd;
    socklen_t clilen;
    pthread_t ntid;
    int err;
    char buf[32];

    // struct prodcons buffer;         /* 全局的环形缓冲区 */
    
    /* 初始化全局的缓冲区 */
    init_buffer(&buffer);

    struct sockaddr_in cliaddr;
    if((clifd=Bind_socket())==-1) /* 绑定套接字 */
    {
        printf ("创建套接字失败\n");
        pthread_exit((void*)-1);
    }
    if((err=pthread_create(&ntid,NULL,Output_Service,NULL))!=0)
        {
            printf("can not create thread:%s\n",strerror(err));
            return -1;
        }
    
    for( ; ; )
    {

        // printf ("waiting for connect...\n");
         clilen=sizeof(cliaddr);
         if((clientfd=accept(clifd,(struct sockaddr*)&cliaddr,&clilen))<0)
         {
             perror("accept");
             pthread_exit((void*)-1);
         }
         inet_ntop(AF_INET,&cliaddr.sin_addr,buf,sizeof(buf));
         printf ("Recieve connection from %s\n",buf);
        
        
         if((err=pthread_create(&ntid,NULL,Client_Service,(void*)&clientfd))!=0)
        {
            printf("can not create thread:%s\n",strerror(err));
            return -1;
        }

        

        int rst;
    }
    
    
    
    return 0;
}

/* 为客户端服务的线程 */
void* Client_Service(void*arg)
{
    int clientfd;
    
    clientfd=*(int *)arg;

         int rstn;
         
         for( ;  ; )
         {
             rstn=receive_message(clientfd,&buffer);
             
             if(rstn==-1)
             {
                 close(clientfd);
                 pthread_exit((void*)-1);
                 
             }else if(rstn==0)
             {
                 close(clientfd);
                 printf ("peer close connection\n");
                 pthread_exit((void*)-1);
             }
             else
             {
                 // buffer[rstn]=0;
                 //printf("receive from client data: %s\n",buffer);
             }

             sleep(1);
         }
    
    
   
}

/* 建立套接字 */
int Bind_socket()
{
    int clifd;

    socklen_t clilen;
    
    struct sockaddr_in servaddr_cli,servaddr_mon,cliaddr;
    
    if((clifd=socket(AF_INET,SOCK_STREAM,0))<0)
    {
         perror("socket");
         return -1;
    }
       

    bzero(&servaddr_cli,sizeof(servaddr_cli));
    servaddr_cli.sin_family=AF_INET;
    servaddr_cli.sin_port=htons(CLIENT_PORT);
    servaddr_cli.sin_addr.s_addr=htonl(INADDR_ANY);

   

    if( bind(clifd,(struct sockaddr*)&servaddr_cli,sizeof(servaddr_cli))<0)
    {
        perror("bind");
        return -1;
    }

    if(listen(clifd,5)<0)
    {
        perror("listen");
        return -1;
    }

    return clifd;
}

void* Output_Service(void*arg)
{

    for( ; ;)
    {
        print_buffer(&buffer);
    }
    
}
